
/*
 * Copyright (c) Developers of JMST
 * Redistributable and modifiable. Please see license.readme for details.
 *
 * ammendment history
 * <date>			<changed by>		<summary of changes>
 * 25 August 2004	Jonee Ryan Ty		First documented history
 *
 */

import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.Cursor;
import java.awt.Color;

import javax.swing.JPanel;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JOptionPane;

 
public class App		extends javax.swing.JApplet			
						implements java.awt.event.ActionListener
{
	MSTCanv mstCanv;
	JPanel 	p1, p2, mstPane;	
	JButton bConnect, bDisconnect, bClear, bPrim, bKruskal;
	 
	public void init() {
		super.init();		
		this.setSize(Constants.APP_WIDTH, Constants.APP_HEIGHT);
		this.setBackground(Constants.BACK_COL);
		this.setup();
	}
	
	public void setup() {
		mstPane = new JPanel(new FlowLayout(FlowLayout.CENTER, 0, 
			Constants.APP_VSPACING));
	
		p1 = new JPanel(new GridLayout(1, 3, 5, 0));
		p1.add(bConnect = new JButton("Connect All"));
		p1.add(bDisconnect = new JButton("Disconnect All"));
		p1.add(bClear = new JButton("Clear"));
		
		mstPane.add(p1);
		
		p2 = new JPanel(new GridLayout(1, 2, 5, 0));
		p2.add(bPrim = new JButton("Prim's Algorithm"));
		p2.add(bKruskal = new JButton("Kruskal's Algorithm"));

		mstPane.add(p2);
		
		mstCanv = new MSTCanv();
		mstCanv.setSize(300, 300);
		
		mstPane.add(mstCanv);
		
		bConnect.addActionListener(this);
		bDisconnect.addActionListener(this);
		bClear.addActionListener(this);
		
		bPrim.addActionListener(this);
		bKruskal.addActionListener(this);
		
		mstCanv.setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
		
		bConnect.setCursor(new Cursor(Cursor.HAND_CURSOR));
		bDisconnect.setCursor(new Cursor(Cursor.HAND_CURSOR));
		bClear.setCursor(new Cursor(Cursor.HAND_CURSOR));
		
		bPrim.setCursor(new Cursor(Cursor.HAND_CURSOR));
		bKruskal.setCursor(new Cursor(Cursor.HAND_CURSOR));
	
		this.getContentPane().add(mstPane);
	}
	 
	public void actionPerformed(java.awt.event.ActionEvent e) {
		Object source = e.getSource();
		
		if(source instanceof JButton) {								
			mstCanv.isSolving = false;
			repaint();
			mstCanv.destroy();
			mstCanv.repaint();			
			
			if(source == bClear) {
				mstCanv.graph.removeAll();				
				mstCanv.colorCounter = 0;			// reset color counter
			
			} else if(source == bConnect) {
				mstCanv.graph.connectAllNodes();
			
			} else if(source == bDisconnect) {
				mstCanv.graph.removeAllEdges();
			
			} else { // if source is either bPrim or bKruskal
				
				if (mstCanv.graph.gNodes.size() != 0) {
					boolean toProceed = true;
				
					toProceed = (source == bPrim)? mstCanv.doPrim() : 
						mstCanv.doKruskal();
				
					if (toProceed)
						mstCanv.animate();	
						
					else
						JOptionPane.showMessageDialog(null, mstCanv.errorMsg, 
							Constants.TITLE, JOptionPane.ERROR_MESSAGE);
				}
			}			
		}
	}	

} //##30
			