
/*
 * Copyright (c) Developers of JMST
 * Redistributable and modifiable. Please see license.readme for details.
 *
 * ammendment history
 * <date>			<changed by>		<summary of changes>
 * 25 August 2004	Jonee Ryan Ty		First documented history
 *
 */
 
import java.util.Vector;


class AnimateMST	extends Thread
{
	public MSTCanv canv;
	public int delay;
	private boolean isInterrupted = false;
	
	public AnimateMST(MSTCanv canv, int delay) {
		this.canv = canv;	
		this.delay = delay;
	}
	
	public void run() {
		Vector edges = null;
		
		try {
			if (canv != null) {
				canv.mouseEventsAreBlocked = true;	
				canv.isSolving = true;
				canv.graph.unincludeAll();
		
				edges = canv.tmpVEdges;
				canv.tmpVEdges = new Vector();
				canv.tmpVNodes = new Vector();
		
			} else
				return;
		
			Edge tmpEdge;
			GNode tmpNode;
		
			if (canv != null)
				canv.repaint();
			mySleep();
		
			if (isInterrupted)
				return;
		
			if (canv != null) {
				if (canv.algo == MSTCanv.PRIM) {
					canv.tmpVNodes.add(canv.random);
					canv.repaint(canv.random.x, canv.random.y, 
						Constants.DIAMETER + 1, Constants.DIAMETER + 1);
					mySleep();	
				}	
			}			
			
			for (int i = 0; i < edges.size(); i++) {
				tmpEdge = (Edge)edges.elementAt(i);
			
				if (canv != null) {
					canv.tmpVEdges.add(tmpEdge);
					tmpEdge.edgIsIncluded = true;
			
					includeNode(tmpEdge.node1);
					includeNode(tmpEdge.node2);
						
					canv.repaint();
			
				} else
					return;
			
				mySleep();		
			
				if (isInterrupted)
					return;
			}
		
			if (canv != null) {
				canv.mouseEventsAreBlocked = false;
				canv.isSolving = false;
			}
		
		} catch (Exception ex) {
			ex.printStackTrace();
			System.out.println("caught\n");
		}
	}
	
	private void mySleep() {
		try {
			this.sleep(delay);
			
		} catch(InterruptedException ie) {
			isInterrupted = true;
		}
	}
	
	private void includeNode(GNode node) {
		if (!node.ndeIsIncluded) {
			canv.tmpVNodes.add(node);
			node.ndeIsIncluded = true;				
		}
	}
}
